/*
** list_delete_item.c for list in /u/a1/deleda_c/rendu/piscine/j6/list
**
** Made by charles-alban deledalle
** Login   <deleda_c@epita.fr>
**
** Started on  Fri Sep 16 23:07:40 2005 charles-alban deledalle
** Last update Sat Sep 17 03:58:40 2005 charles-alban deledalle
*/

#include <stdlib.h>
#include "s_list.h"

void		*list_delete_item(struct s_list **list,
				  const void	*data,
				  t_cmp_func	cmp_func)
{
  struct s_list	*tmp;
  void		*tmpdata;

  if (!*list)
    return NULL;
  else
    if (!cmp_func(data, (*list)->data))
      {
	tmp = *list;
	tmpdata = (*list)->data;
	*list = (*list)->next;
	free(tmp);
	return tmpdata;
      }
    else
      return list_delete_item(&((*list)->next),
			      data,
			      cmp_func);
}
